import random
import string
from utils import wait
import numpy as np


class MockEETask(object):
	# config
	SLEEP=False
	SLEEP_TIME=0.3
	STATE_RATIOS=[0,5,25,10,1,0,0]
	ID_LENGTH=24
	# states
	UNSUBMITTED='UNSUBMITTED'
	READY='READY'
	RUNNING='RUNNING'
	COMPLETED='COMPLETED'
	FAILED='FAILED'
	CANCEL_REQUESTED='CANCEL_REQUESTED'
	CANCELLED='CANCELLED'
	STATES=[UNSUBMITTED,READY,RUNNING,COMPLETED,FAILED,CANCEL_REQUESTED,CANCELLED]
	# props
	sleep=None
	id=None

	#
	# PUBLIC METHODS
	#	
	def __init__(self,id=None,sleep=SLEEP):
		self.id=id or self._id_generator()
		self.sleep=sleep


	def status(self,state=None,state_ratios=STATE_RATIOS,create_ts=5,start_delta=5,runtime=10):
		if self.sleep: wait(self.SLEEP_TIME,'MockEETask.status')
		status={
			'id':self.id,
			'state': self._get_state(state,state_ratios),
			'creation_timestamp_ms':create_ts,
			'start_timestamp_ms':create_ts+start_delta,
			'update_timestamp_ms':create_ts+start_delta+runtime
		}
		return status

	#
	# INTERNAL METHODS
	#	
	def _get_state(self,state,state_ratios):
		if state: return state
		else: 
			norm=sum(state_ratios)
			state_probs=map(lambda x: float(x)/norm,state_ratios)
			return np.random.choice(self.STATES,p=state_probs)


	def _id_generator(self,size=ID_LENGTH, chars=string.ascii_uppercase + string.digits):
		return ''.join(random.choice(chars) for _ in range(size))